macro draw_button xpos,ypos,xsize,ysize,id,color
{
	mov eax,8
	mov ebx,xpos
	shl ebx,16
	add ebx,xsize
	mov ecx,ypos
	shl ecx,16
	add ecx,ysize
	mov edx,id
	mov esi,color
	int 0x40
}

macro draw_rectangle xpos,ypos,xsize,ysize,color
{
  mov eax,13
  mov ebx,xpos
  shl ebx,16
  add ebx,xsize
  mov ecx,ypos
  shl ecx,16
  add ecx,ysize
  mov edx,color
  int 0x40
}

macro draw_line x1,y1,x2,y2,color
{
	mov eax,38
	mov ebx,x1
	shl ebx,16
	add ebx,x2
	mov ecx,y1
	shl ecx,16
	add ecx,y2
	mov edx,color
	int 0x40

}
  use32
  org	 0x0

  db	 'MENUET01'
  dd	 0x01
  dd	 START
  dd	 _END
  dd	 I_END+0x1000
  dd	 I_END+0x1000
  dd	 0x0
  dd	 0x0
include "dockini.inc"
include "dockparser.inc"
include "icons.inc"

START:

	loaddockcfgfile
	mov eax,61
	mov ebx,1
	int 0x40
	xor ebx,ebx
	xor ecx,ecx
	mov cx,ax
	shr eax,16
	mov bx,ax
	sub ebx,400
	shr ebx,1
	mov [x_pos],ebx
	sub ecx,60
	mov [y_pos],ecx

	mov eax,48
	mov ebx,1
	mov ecx,1
	int 0x40
red:

    call draw_window

still:
    mov eax,10
    int 0x40

    cmp  eax,1
    je	 red
    cmp  eax,2
    je	 key
    cmp  eax,3
    je	 button
    jmp  still



  key:
    mov eax,2
    int 0x40
    jmp  still

  button:
    mov eax,17
    int 0x40
    shr eax,8
    mov [btn_id],eax

    cmp [pid],0
    jna nokill
    mov eax,18
    mov ebx,18
    mov ecx,[pid]
    int 0x40

    nokill:
    mov eax,[btn_id]
    cmp  eax,8
    ja .nodock
    dec eax
    imul eax,120
    add eax,dockcfg
    add eax,60
    mov [fileinfo.subfunct],0x7
    mov [fileinfo.bytes],   0x0
    mov [fileinfo.buffer],  0x0
    mov [fileinfo.ptrpath], eax
    mov [fileinfo.params],  0x0
    mov eax,70
    mov ebx,fileinfo
   int	0x40
   jmp still
  .nodock:
    sub eax,10
    mov [currentp],eax



    mov [fileinfo.subfunct],0x7
    mov [fileinfo.params],  currentp
    mov [fileinfo.bytes],   0x0
    mov [fileinfo.buffer],  0x0
    mov [fileinfo.ptrpath], tmenu
    mov eax,70
    mov ebx,fileinfo
    int 0x40

    mov [pid],eax
    jmp still

  .exit:
	mov eax,-1
	int 0x40


draw_window:
  mov eax,12	;begin of redraw
  mov ebx,1
  int 0x40

  mov eax,0
  mov ebx,[x_pos]
  shl ebx,16
  mov bx,399
  mov ecx,[y_pos]
  shl ecx,16
  mov cx,54
  mov edx,0x01000000
  mov esi,0x01000000
  int 0x40


;======== boutons d'applications========
 draw_button	13,18,33,33,1,0x00224488
 draw_button	53,18,33,33,2,0x00224488
 draw_button	93,18,33,33,3,0x00224488
 draw_button   133,18,33,33,4,0x00224488

 draw_button   233,18,33,33,5,0x00224488
 draw_button   273,18,33,33,6,0x00224488
 draw_button   313,18,33,33,7,0x00224488
 draw_button   353,18,33,33,8,0x00224488
;=======================================

;======== boutons de menu =============
 draw_button	10,0,39,14,11,0x00224488
 draw_button	50,0,39,14,12,0x00224488
 draw_button	90,0,39,14,13,0x00224488
 draw_button   130,0,39,14,14,0x00224488

 draw_button   230,0,39,14,15,0x00224488
 draw_button   270,0,39,14,16,0x00224488
 draw_button   310,0,39,14,17,0x00224488
 draw_button   350,0,39,14,18,0x00224488
;======================================



;========= draw the skin =============
mov [fileinfo.subfunct],0x5
mov [fileinfo.bytes],0x0
mov [fileinfo.buffer],dbid
mov [fileinfo.ptrpath],skin
mov eax,70
mov ebx,fileinfo
int 0x40
mov [fileinfo.subfunct],0x0
mov [fileinfo.buffer],skindata
mov ebx,[dbid+32]
mov [fileinfo.bytes],ebx
mov [fileinfo.ptrpath],skin
mov [fileinfo.params],0x0
mov eax,70
mov ebx,fileinfo
int 0x40

mov eax,7
mov ebx,skindata
mov ecx,400*65536+55
xor edx,edx
int 0x40

;====================================

;====== draw icons ==============

    mov [cpt],0
    foricnx:
    mov ecx,[cpt]
    cmp ecx,4
    jnb nexticnx

      mov [icnx],ecx	    ; sauve le numro en cours
      imul ecx,120	    ; on calcule l'adresse du nom de
      add  ecx,dockcfg	    ; l'icone
      mov  ebx,[icnx]	    ; on calcule la position
      imul ebx,40	    ;
      add  ebx,13	    ;
	cmp byte [ecx],0
	jna .suite1
      push ecx
      push ebx
      push 18
      call drwicon
	.suite1:
    inc [cpt]
    jmp foricnx
    nexticnx:

    mov ecx,4
    foricnx2:
    mov ecx,[cpt]
    cmp ecx,8
    jnb nexticnx2

      mov [icnx],ecx	    ; sauve le numro en cours
      imul ecx,120	    ; on calcule l'adresse du nom de
      add  ecx,dockcfg	    ; l'icone
      mov  ebx,[icnx]	    ; on calcule la position
      sub  ebx,4
      imul ebx,40	    ;
      add  ebx,233	    ;
	cmp byte [ecx],0
	jna .suite2
      push ecx
      push ebx
      push 18
      call drwicon
	.suite2:
    inc [cpt]
    jmp foricnx2
    nexticnx2:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   mov eax,12		;end of redraw
   mov ebx,2
   int 0x40
   ret


;;;;;;;;;;
;; Data ;;
;;;;;;;;;;
cpt1 dd 0x0
cpt2 dd 0x0
pid dd 0
currentp dd 0,0
cpt   dd 0x0
icnx  dd 0x0
x_pos dd 0x0
y_pos dd 0x0
btn_id dd 0x0
dockcfgfile   : db '/rd/1/dockini.dat',0
tmenu	      : db '/rd/1/@tmenu',0
skin	      : db '/hd0/1/kolibri/icons/skin.raw',0

_END:
dockcfg rb 1200
skindata:
	rb 88000
icon_buffer:rb 32*32*4+52
I_END:

